
#ifndef LOWERSTR_H
#define LOWERSTR_H

#include <objbase.h>
#include "guid.h"


class ILowerStr	: public IUnknown
{
public:
    virtual STDMETHODIMP  Lower(char *lpInput, char**lpOutput) = 0;
};


class CLowerStr : public ILowerStr 
{
public:
    STDMETHODIMP QueryInterface(REFIID iid, LPVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    STDMETHODIMP Lower(char *lpString, char**lpOutput);

    CLowerStr();
    ~CLowerStr();

private:
    DWORD m_dwRef;
};

class CLowerStrClassFactory:public IClassFactory
{

  protected:
    DWORD m_dwRef;

  
  public:
   CLowerStrClassFactory(void);
   ~CLowerStrClassFactory(void);

//IUnknown
   STDMETHODIMP QueryInterface (REFIID iid ,void **ppv);
   STDMETHODIMP_ (ULONG) AddRef(void);
   STDMETHODIMP_ (ULONG) Release(void);

   STDMETHODIMP CreateInstance(IUnknown *punkOuter,REFIID iid,void **ppv);
   STDMETHODIMP LockServer(BOOL);
};

#endif

