
#include <windows.h>
#include <stdio.h>
#include <olectl.h>
#include <olectlid.h>

#include "guid.h"


//Prototypes for local functions
HRESULT RegisterLocalServer(REFCLSID rclsid);
HRESULT UnregisterLocalServer(REFCLSID rclsid);

//CLSID for the server object

class ILowerStr:public IUnknown
{
public:
	virtual STDMETHODIMP Lower(char*, char**)=0;
};

//The CConnectionPoint class implements the server object.
class CLowerStr : public ILowerStr
{
private:
    DWORD  m_dwRef;
public:
    //constructor
    CLowerStr();
	~CLowerStr();

    
	STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	STDMETHODIMP Lower(char*, char**); 
};


class CLowerStrClassFactory : public IClassFactory
{
private:
    DWORD   m_dwRef;

public:
    CLowerStrClassFactory();
	~CLowerStrClassFactory();

	STDMETHODIMP QueryInterface(REFIID iid, void **ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	
	STDMETHODIMP CreateInstance(IUnknown *punkOuter, REFIID riid, void **ppv);
    STDMETHODIMP LockServer(BOOL fLock);
};


